VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_thumbnail_web_page"
   ClientHeight    =   2295
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6720
   LinkTopic       =   "Form1"
   ScaleHeight     =   2295
   ScaleWidth      =   6720
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picThumbnail 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   735
      Left            =   4680
      ScaleHeight     =   49
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   81
      TabIndex        =   12
      Top             =   240
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.PictureBox picImage 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   735
      Left            =   3240
      ScaleHeight     =   49
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   81
      TabIndex        =   11
      Top             =   240
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.TextBox txtThumbHeight 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   1440
      TabIndex        =   5
      Text            =   "100"
      Top             =   1920
      Width           =   1095
   End
   Begin VB.TextBox txtThumbWidth 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   1440
      TabIndex        =   4
      Text            =   "100"
      Top             =   1560
      Width           =   1095
   End
   Begin VB.TextBox txtWebPage 
      Height          =   285
      Left            =   1440
      TabIndex        =   3
      Text            =   "Pictures.html"
      Top             =   1200
      Width           =   5175
   End
   Begin VB.TextBox txtUrlPrefix 
      Height          =   285
      Left            =   1440
      TabIndex        =   2
      Top             =   840
      Width           =   5175
   End
   Begin VB.CommandButton btnGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   3360
      TabIndex        =   6
      Top             =   1680
      Width           =   1215
   End
   Begin VB.TextBox txtOutputDir 
      Height          =   285
      Left            =   1440
      TabIndex        =   1
      Top             =   480
      Width           =   5175
   End
   Begin VB.TextBox txtInputDir 
      Height          =   285
      Left            =   1440
      TabIndex        =   0
      Top             =   120
      Width           =   5175
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Thumb Height:"
      Height          =   195
      Index           =   5
      Left            =   120
      TabIndex        =   14
      Top             =   1920
      Width           =   1050
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Thumb Width:"
      Height          =   195
      Index           =   4
      Left            =   120
      TabIndex        =   13
      Top             =   1560
      Width           =   1005
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Web Page:"
      Height          =   195
      Index           =   3
      Left            =   120
      TabIndex        =   10
      Top             =   1200
      Width           =   810
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "URL Prefix:"
      Height          =   195
      Index           =   2
      Left            =   120
      TabIndex        =   9
      Top             =   840
      Width           =   810
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Output Directory:"
      Height          =   195
      Index           =   1
      Left            =   120
      TabIndex        =   8
      Top             =   480
      Width           =   1200
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Input Directory:"
      Height          =   195
      Index           =   0
      Left            =   120
      TabIndex        =   7
      Top             =   120
      Width           =   1080
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Initialize the input and output directories.
Private Sub Form_Load()
Dim dirname As String

    dirname = App.Path
    If Right$(dirname, 1) <> "\" Then dirname = dirname & "\"

    txtInputDir.Text = dirname & "Input"
    txtOutputDir.Text = dirname & "Output"
End Sub

' Make the TextBoxes as big as possible.
Private Sub Form_Resize()
Dim wid As Integer

    wid = ScaleWidth - txtInputDir.Left - 120
    If wid < 120 Then wid = 120
    txtInputDir.Width = wid
    txtOutputDir.Width = wid
    txtUrlPrefix.Width = wid
    txtWebPage.Width = wid
End Sub

' Make the web page and thumbnails.
Private Sub btnGo_Click()
Dim input_dir As String
Dim output_dir As String
Dim url_prefix As String
Dim thumb_width As Integer
Dim thumb_height As Integer
    
    ' Get inputs.
    input_dir = txtInputDir.Text
    If Right$(input_dir, 1) <> "\" Then input_dir = input_dir & "\"
    output_dir = txtOutputDir.Text
    If Right$(output_dir, 1) <> "\" Then output_dir = output_dir & "\"
    url_prefix = txtUrlPrefix.Text
    If (Len(url_prefix) > 0) And (Right$(url_prefix, 1) <> "\") Then url_prefix = url_prefix & "\"
    thumb_width = Val(txtThumbWidth.Text)
    thumb_height = Val(txtThumbHeight.Text)

    ' Do the work.
    MakeWebPage input_dir, output_dir, url_prefix, thumb_width, thumb_height, txtWebPage.Text
End Sub

' Make the web page and thumbnails.
Private Sub MakeWebPage(ByVal input_dir As String, ByVal output_dir As String, ByVal url_prefix As String, ByVal thumb_width As Integer, ByVal thumb_height As Integer, ByVal webpage_name As String)
Dim filenum As Integer
Dim html_filename As String
Dim files As Collection
Dim image_filename As Variant
Dim src_filename As String
Dim dest_filename As String
Dim original_width As Integer
Dim original_height As Integer
Dim shrunk_width As Integer
Dim shrunk_height As Integer
Dim scale1 As Double
Dim scale2 As Double
Dim thumb_scale As Double
Dim pos As Integer
Dim thumb_filename As String

    ' Open the HTML file.
    html_filename = output_dir & webpage_name
    filenum = FreeFile
    Open html_filename For Output As #filenum
    
    ' Make a list of the image files.
    Set files = FindFiles(input_dir, "*.jpg;*.bmp;*.gif")

    ' Process the files.
    For Each image_filename In files
        ' Copy the file to the destination directory.
        src_filename = input_dir & image_filename
        dest_filename = output_dir & image_filename
        FileCopy src_filename, dest_filename

        ' Get the image.
        picImage.Picture = LoadPicture(src_filename)

        ' Get the original size.
        original_width = picImage.ScaleWidth
        original_height = picImage.ScaleHeight

        ' Shrink the image.
        scale1 = thumb_width / original_width
        scale2 = thumb_height / original_height
        If (scale1 < scale2) Then
            thumb_scale = scale1
        Else
            thumb_scale = scale2
        End If
        shrunk_width = CInt(original_width * thumb_scale)
        shrunk_height = CInt(original_height * thumb_scale)
        picThumbnail.Width = Me.ScaleX(shrunk_width, vbPixels, ScaleMode)
        picThumbnail.Height = Me.ScaleY(shrunk_height, vbPixels, ScaleMode)

        ' Copy the image at reduced scale.
        picThumbnail.PaintPicture _
            picImage.Picture, _
            0, 0, shrunk_width, shrunk_height, _
            0, 0, original_width, original_height

        ' Save the thumbnail image.
        pos = InStrRev(image_filename, ".")
        thumb_filename = Left$(image_filename, pos - 1) & "_thumb.bmp"
        SavePicture picThumbnail.Image, output_dir & thumb_filename

        ' Add the thumbnail image to the HTML page.
        Print #filenum, _
            "<a href=""" & url_prefix & image_filename & """>" & _
            "<img src=""" & url_prefix & thumb_filename & """>" & _
            "</a>"
    Next image_filename

    ' Close the HTML file.
    Close #filenum

    MsgBox "Processed " & files.Count & " images."
End Sub

' Return a list of files that match the patterns.
Private Function FindFiles(ByVal dirname As String, ByVal patterns As String) As Collection
Dim pattern_array() As String
Dim pattern As Variant
Dim files As Collection
Dim filename As String

    ' Separate the patterns.
    pattern_array = Split(patterns, ";")

    Set files = New Collection
    ' Loop through the files in the directory.
    filename = Dir$(dirname)
    Do While Len(filename) > 0
        ' See if the name matches any pattern.
        For Each pattern In pattern_array
            If filename Like pattern Then
                files.Add filename
                Exit For
            End If
        Next pattern

        filename = Dir$()
    Loop

    Set FindFiles = files
End Function
